package com.muyu.etl.config;

import com.alibaba.druid.pool.DruidDataSource;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.etl.RemoteDataAccessService;
import com.muyu.etl.datasource.MyDataSource;
import com.muyu.etl.domain.DataSource;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.util.List;

/**
 * @ClassName DataAccessClientRunner
 * @Description 描述
 * @Author Xin.Yao
 * @Date 2024/5/9 19:53
 */
@Log4j2
public class DataAccessClientRunner implements ApplicationRunner {
    @Autowired
    private RemoteDataAccessService remoteDataAccessService;
    @Override
    public void run(ApplicationArguments args) throws Exception {
        Result<TableDataInfo<DataSource>> result = remoteDataAccessService.list(new DataSource());
        List<DataSource> dataSourceList = result.getData().getRows();
        MyDataSource.info(dataSourceList);
    }
}
