package com.muyu.etl.domain;

import com.muyu.common.core.annotation.Excel;
import com.muyu.common.core.web.domain.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.util.List;

/**
 * 【请填写功能名称】对象 asset_model
 *
 * @author ruoyi
 * @date 2024-04-22
 */
@EqualsAndHashCode(callSuper = true)
@SuperBuilder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class AssetModel extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 数据资产ID */
    @Excel(name = "数据资产ID")
    private Long dataAssetId;

    /** 字段名 */
    @Excel(name = "字段名")
    private String name;

    /** 字段备注 */
    @Excel(name = "字段备注")
    private String comment;

    /** 是否主键 */
    @Excel(name = "是否主键")
    private String isPrimaryKey;

    /** 数据类型 */
    @Excel(name = "数据类型")
    private String type;

    /** 映射数据类型 */
    @Excel(name = "映射数据类型")
    private String mappingType;

    /** 长度 */
    @Excel(name = "长度")
    private String length;

    /** 小数位 */
    @Excel(name = "小数位")
    private String decimalPlaces;

    /** 是否不可为空 */
    @Excel(name = "是否不可为空")
    private String isNull;

    /** 是否字典 */
    @Excel(name = "是否字典")
    private String isDict;

    /** 默认值 */
    @Excel(name = "默认值")
    private String defaultValue;

    /** 字典key */
    @Excel(name = "字典key")
    private String dictKey;
    /** 字典id */
    @Excel(name = "字典key")
    private Long dictionaryId;

    /** 字典信息 */
    @Excel(name = "字典信息")
    private List<DictionaryData> dictionaryDatas;

}
