package com.muyu.etl.domain;

import com.muyu.common.core.annotation.Excel;
import com.muyu.common.core.web.domain.BaseEntity;
import com.muyu.common.security.utils.SecurityUtils;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Date;

/**
 * 【请填写功能名称】对象 data_asset
 *
 * @author ruoyi
 * @date 2024-04-22
 */
@SuperBuilder
@Data
@AllArgsConstructor
@NoArgsConstructor
public class DataAsset extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 主键 */
    private Long id;

    /** 数据接入ID */
    @Excel(name = "数据接入ID")
    private Long dataSourceId;

    /** 表名称 */
    @Excel(name = "表名称")
    private String tableName;

    /** 表备注 */
    @Excel(name = "表备注")
    private String tableComment;

    /** 数据量 */
    @Excel(name = "数据量")
    private Long tableCount;

    /** 资产模型 */
    @Excel(name = "资产模型")
    private Long fields;

    public DataAsset dataAssetBuilder(DataSource dataSource, ResultSet resultSet) {
        try {
            return DataAsset.builder()
                    .tableName(resultSet.getString("t_name"))
                    .tableComment(resultSet.getString("table_comment") == null ? "-":resultSet.getString("table_comment"))
                    .tableCount(Long.valueOf(resultSet.getString("table_rows")))
                    .fields(Long.valueOf(resultSet.getString("fields")))
                    .dataSourceId(dataSource.getId())
                    .createBy(SecurityUtils.getUsername())
                    .createTime(new Date())
                    .build();
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }

    }
}
