package com.muyu.etl.domain;

import com.muyu.common.core.annotation.Excel;
import com.muyu.common.core.web.domain.BaseEntity;
import com.muyu.etl.domain.custom.TableDetail;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.util.List;

/**
 * 【请填写功能名称】对象 data_source
 *
 * @author ruoyi
 * @date 2024-04-20
 */
@Data
@AllArgsConstructor
@NoArgsConstructor
@SuperBuilder
public class DataSource extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** $column.columnComment */
    private Long id;

    /** $column.columnComment */
    private String dataSourceName;

    /** $column.columnComment */
    private String linkAddress;

    /** $column.columnComment */
    private String port;
    private String sql;

    /** $column.columnComment */
    private String databaseName;

    /** $column.columnComment */
    private String username;

    /** $column.columnComment */
    private String password;

    private String tableName;

    /** 数据连接参数 */
    @Excel(name = "数据连接参数")
    private String connectionParam;

    /** 初始连接数量 */
    @Excel(name = "初始连接数量")
    private Long initNum;

    /** 最大连接数量 */
    @Excel(name = "最大连接数量")
    private Long maxNum;
    private Long count;

    /** 最大等待时间 */
    @Excel(name = "最大等待时间")
    private Long maxWaitTime;

    /** 最大等待次数 */
    @Excel(name = "最大等待次数")
    private Long maxWaitSize;

    /** $column.columnComment */
    private String type;

    /** 数据来源名称 */
    @Excel(name = "数据来源名称")
    private String systemName;
    /** 连接驱动名称 */
    @Excel(name = "连接驱动名称")
    private String jdbcDriver;

    /** 模式名称 */
    @Excel(name = "数据来源名称")
    private String modeName;

}
