package com.muyu.etl;

import com.muyu.common.core.constant.ServiceNameConstants;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.etl.domain.AssetModel;
import com.muyu.etl.factory.DataAccessFallbackFactory;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * @ClassName RemoteAssetModelService
 * @Description 描述
 * @Author Xin.Yao
 * @Date 2024/5/12 9:42
 */
@FeignClient(contextId = "remoteAssetModelService",
        value = ServiceNameConstants.DATA_ACCESS_SERVICE,
        fallbackFactory = DataAccessFallbackFactory.class)
public interface RemoteAssetModelService {
    @PostMapping("/model/list")
    public Result<TableDataInfo<AssetModel>> list(@RequestBody AssetModel assetModel);
}
