package com.muyu.etl;

import com.muyu.common.core.constant.ServiceNameConstants;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.etl.domain.DataSource;
import com.muyu.etl.factory.DataAccessFallbackFactory;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * @ClassName RemoteDataAccessService
 * @Description 描述
 * @Author Xin.Yao
 * @Date 2024/5/9 19:45
 */
@FeignClient(contextId = "remoteDataAccessService",
        value = ServiceNameConstants.DATA_ACCESS_SERVICE,
        fallbackFactory = DataAccessFallbackFactory.class)
public interface RemoteDataAccessService {
    @PostMapping("/source/list")
    public Result<TableDataInfo<DataSource>> list(@RequestBody DataSource dataSource);
}
