package com.muyu.etl.factory;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.etl.RemoteAssetModelService;
import com.muyu.etl.RemoteDataAccessService;
import com.muyu.etl.domain.AssetModel;
import com.muyu.etl.domain.DataSource;
import org.springframework.cloud.openfeign.FallbackFactory;

/**
 * @ClassName DataAccessFallbackFactory
 * @Description 描述
 * @Author Xin.Yao
 * @Date 2024/5/9 19:47
 */
public class AssetModelFallbackFactory implements FallbackFactory<RemoteAssetModelService> {
    @Override
    public RemoteAssetModelService create(Throwable cause) {
        return new RemoteAssetModelService() {
            @Override
            public Result<TableDataInfo<AssetModel>> list(AssetModel assetModel) {
                return Result.error("获取数据模型列表失败");
            }
        };
    }
}
