package com.muyu.etl.factory;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.etl.RemoteDataAccessService;
import com.muyu.etl.domain.DataSource;
import org.springframework.cloud.openfeign.FallbackFactory;

/**
 * @ClassName DataAccessFallbackFactory
 * @Description 描述
 * @Author Xin.Yao
 * @Date 2024/5/9 19:47
 */
public class DataAccessFallbackFactory implements FallbackFactory<RemoteDataAccessService> {
    @Override
    public RemoteDataAccessService create(Throwable cause) {
        return new RemoteDataAccessService() {

            @Override
            public Result<TableDataInfo<DataSource>> list(DataSource dataSource) {
                return Result.error("获取数据源列表失败");
            }
        };
    }
}
