package com.muyu.etl.controller;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.poi.ExcelUtil;
import com.muyu.common.core.web.controller.BaseController;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.common.log.annotation.Log;
import com.muyu.common.log.enums.BusinessType;
import com.muyu.etl.domain.AssetAccredit;
import com.muyu.etl.domain.req.AssetAccreditReq;
import com.muyu.etl.service.IAssetAccreditService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * 【请填写功能名称】Controller
 *
 * @author ruoyi
 * @date 2024-04-25
 */
@RestController
@RequestMapping("/assetAccredit")
public class AssetAccreditController extends BaseController
{
    @Autowired
    private IAssetAccreditService assetAccreditService;

    /**
     * 查询【请填写功能名称】列表
     */
    @GetMapping("/list")
    public Result<TableDataInfo<AssetAccredit>> list(AssetAccredit assetAccredit)
    {
        startPage();
        List<AssetAccredit> list = assetAccreditService.selectAssetAccreditList(assetAccredit);
        return getDataTable(list);
    }

    /**
     * 导出【请填写功能名称】列表
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, AssetAccredit assetAccredit)
    {
        List<AssetAccredit> list = assetAccreditService.selectAssetAccreditList(assetAccredit);
        ExcelUtil<AssetAccredit> util = new ExcelUtil<AssetAccredit>(AssetAccredit.class);
        util.exportExcel(response, list, "【请填写功能名称】数据");
    }

    /**
     * 获取【请填写功能名称】详细信息
     */
    @GetMapping(value = "/{id}")
    public Result getInfo(@PathVariable("id") Long id)
    {
        return success(assetAccreditService.selectAssetAccreditById(id));
    }


    /**
     * 根据表id获取授权信息
     */
    @GetMapping(value = "/GetAssetAccreditByDataAssetId")
    public Result getAssetAccreditByDataAssetId(@RequestParam("id") Long id)
    {
        return assetAccreditService.getAssetAccreditByDataAssetId(id);
    }

    /**
     * 新增【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.INSERT)
    @PostMapping
    public Result add(@RequestBody AssetAccreditReq assetAccreditReq)
    {
        return assetAccreditService.insertAssetAccredit(assetAccreditReq);
    }

    /**
     * 授权删除
     */
    @Log(title = "授权删除", businessType = BusinessType.INSERT)
    @PostMapping("/DeleteAssetAccreditByAssetIds")
    public Result deleteSourceAccreditBySourceIds(@RequestBody AssetAccreditReq assetAccreditReq)
    {
        return assetAccreditService.deleteAssetAccreditByAssetIds(assetAccreditReq);
    }

    /**
     * 修改【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.UPDATE)
    @PutMapping
    public Result edit(@RequestBody AssetAccredit assetAccredit)
    {
        return toAjax(assetAccreditService.updateAssetAccredit(assetAccredit));
    }

    /**
     * 删除【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public Result remove(@PathVariable Long[] ids)
    {
        return toAjax(assetAccreditService.deleteAssetAccreditByIds(ids));
    }
}
