package com.muyu.etl.controller;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.poi.ExcelUtil;
import com.muyu.common.core.web.controller.BaseController;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.common.log.annotation.Log;
import com.muyu.common.log.enums.BusinessType;
import com.muyu.etl.domain.AssetModel;
import com.muyu.etl.service.IAssetModelService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * 【请填写功能名称】Controller
 *
 * @author ruoyi
 * @date 2024-04-22
 */
@RestController
@RequestMapping("/model")
public class AssetModelController extends BaseController
{
    @Autowired
    private IAssetModelService assetModelService;

    /**
     * 查询【请填写功能名称】列表
     */
    @PostMapping("/list")
    public Result<TableDataInfo<AssetModel>> list(@RequestBody AssetModel assetModel)
    {
        startPage();
        List<AssetModel> list = assetModelService.selectAssetModelList(assetModel);
        return getDataTable(list);
    }

    /**
     * 导出【请填写功能名称】列表
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, AssetModel assetModel)
    {
        List<AssetModel> list = assetModelService.selectAssetModelList(assetModel);
        ExcelUtil<AssetModel> util = new ExcelUtil<AssetModel>(AssetModel.class);
        util.exportExcel(response, list, "【请填写功能名称】数据");
    }

    /**
     * 获取【请填写功能名称】详细信息
     */
    @GetMapping(value = "/{id}")
    public Result getInfo(@PathVariable("id") Long id)
    {
        return success(assetModelService.selectAssetModelById(id));
    }

    /**
     * 新增【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.INSERT)
    @PostMapping
    public Result add(@RequestBody AssetModel assetModel)
    {
        return toAjax(assetModelService.insertAssetModel(assetModel));
    }

    /**
     * 修改【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.UPDATE)
    @PostMapping("/UpdateAssetModel")
    public Result edit(@RequestBody AssetModel assetModel)
    {
        return toAjax(assetModelService.updateAssetModel(assetModel));
    }

    /**
     * 删除【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public Result remove(@PathVariable Long[] ids)
    {
        return toAjax(assetModelService.deleteAssetModelByIds(ids));
    }
}
