package com.muyu.etl.controller;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.poi.ExcelUtil;
import com.muyu.common.core.web.controller.BaseController;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.common.log.annotation.Log;
import com.muyu.common.log.enums.BusinessType;
import com.muyu.etl.domain.Dictionary;
import com.muyu.etl.service.IDictionaryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * 【请填写功能名称】Controller
 *
 * @author ruoyi
 * @date 2024-04-24
 */
@RestController
@RequestMapping("/dictionary")
public class DictionaryController extends BaseController
{
    @Autowired
    private IDictionaryService dictionaryService;

    /**
     * 查询【请填写功能名称】列表
     */
    @GetMapping("/list")
    public Result<TableDataInfo<Dictionary>> list(Dictionary dictionary)
    {
        startPage();
        List<Dictionary> list = dictionaryService.selectDictionaryList(dictionary);
        return getDataTable(list);
    }

    /**
     * 导出【请填写功能名称】列表
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, Dictionary dictionary)
    {
        List<Dictionary> list = dictionaryService.selectDictionaryList(dictionary);
        ExcelUtil<Dictionary> util = new ExcelUtil<Dictionary>(Dictionary.class);
        util.exportExcel(response, list, "【请填写功能名称】数据");
    }

    /**
     * 获取【请填写功能名称】详细信息
     */
    @GetMapping(value = "/{id}")
    public Result getInfo(@PathVariable("id") Long id)
    {
        return success(dictionaryService.selectDictionaryById(id));
    }

    /**
     * 根据数据源id获取字典详细信息
     */
    @GetMapping(value = "/GetDictionaryList")
    public Result getDictionaryList(@RequestParam("dataSourceId") Long dataSourceId){
        return dictionaryService.getDictionaryList(dataSourceId);
    }

    /**
     * 根据key删除字典详细信息
     */
    @GetMapping(value = "/DeleteDictionary")
    public Result deleteDictionary(@RequestParam("id") Long id){
        return dictionaryService.deleteDictionary(id);
    }


    /**
     * 新增【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.INSERT)
    @PostMapping
    public Result add(@RequestBody Dictionary dictionary)
    {
        return toAjax(dictionaryService.insertDictionary(dictionary));
    }

    /**
     * 修改【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.UPDATE)
    @PutMapping
    public Result edit(@RequestBody Dictionary dictionary)
    {
        return toAjax(dictionaryService.updateDictionary(dictionary));
    }

    /**
     * 删除【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public Result remove(@PathVariable Long[] ids)
    {
        return toAjax(dictionaryService.deleteDictionaryByIds(ids));
    }
}
