package com.muyu.etl.service.impl;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.DateUtils;
import com.muyu.common.security.utils.SecurityUtils;
import com.muyu.common.system.domain.SysUser;
import com.muyu.common.system.remote.RemoteUserService;
import com.muyu.etl.domain.AssetAccredit;
import com.muyu.etl.domain.model.AccreditModel;
import com.muyu.etl.domain.req.AssetAccreditReq;
import com.muyu.etl.mapper.AssetAccreditMapper;
import com.muyu.etl.service.IAssetAccreditService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Objects;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author ruoyi
 * @date 2024-04-25
 */
@Service
public class AssetAccreditServiceImpl implements IAssetAccreditService
{
    @Autowired
    private AssetAccreditMapper assetAccreditMapper;

    @Autowired
    private RemoteUserService remoteUserService;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    @Override
    public AssetAccredit selectAssetAccreditById(Long id)
    {
        return assetAccreditMapper.selectAssetAccreditById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     *
     * @param assetAccredit 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<AssetAccredit> selectAssetAccreditList(AssetAccredit assetAccredit)
    {
        return assetAccreditMapper.selectAssetAccreditList(assetAccredit);
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param assetAccreditReq 【请填写功能名称】
     * @return 结果
     */
    @Override
    public Result insertAssetAccredit(AssetAccreditReq assetAccreditReq)
    {
        deleteAssetAccreditByAssetIds(assetAccreditReq);
        List<AssetAccredit> assetAccredits = new ArrayList<>();
        if (assetAccreditReq.getUserId() != null){
            AssetAccredit assetAccredit = new AssetAccredit();
            assetAccredit.setDataAssetId(assetAccreditReq.getDataAssetId());
            assetAccredit.setUserId(assetAccreditReq.getUserId());
            assetAccredit.setCreateBy(SecurityUtils.getUsername());
            assetAccredit.setCreateTime(new Date());
            assetAccredits.add(assetAccredit);
        }else{
            assetAccredits.addAll(assetAccreditReq.getDeptIds().stream().map(deptId -> {
                AssetAccredit assetAccredit = new AssetAccredit();
                assetAccredit.setDataAssetId(assetAccreditReq.getDataAssetId());
                assetAccredit.setDeptId(deptId);
                assetAccredit.setCreateBy(SecurityUtils.getUsername());
                assetAccredit.setCreateTime(new Date());
                return assetAccredit;
            }).toList());
            List<Long> deptIds = assetAccreditReq.getDeptIds();
            Result<List<SysUser>> list = remoteUserService.userList(new SysUser());
            List<SysUser> sysUsers = list.getData();
            assetAccredits.addAll(sysUsers.stream().filter(sysUser -> deptIds.contains(sysUser.getDeptId())).toList().stream().map(sysUser -> {
                AssetAccredit assetAccredit = new AssetAccredit();
                assetAccredit.setDataAssetId(assetAccreditReq.getDataAssetId());
                assetAccredit.setUserId(sysUser.getUserId());
                assetAccredit.setCreateBy(SecurityUtils.getUsername());
                assetAccredit.setCreateTime(new Date());
                return assetAccredit;
            }).toList());
        }
        assetAccreditMapper.insertBatchAssetAccredit(assetAccredits);
        return Result.success();
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param assetAccredit 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updateAssetAccredit(AssetAccredit assetAccredit)
    {
        assetAccredit.setUpdateTime(DateUtils.getNowDate());
        return assetAccreditMapper.updateAssetAccredit(assetAccredit);
    }

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteAssetAccreditByIds(Long[] ids)
    {
        return assetAccreditMapper.deleteAssetAccreditByIds(ids);
    }

    /**
     * 删除【请填写功能名称】信息
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteAssetAccreditById(Long id)
    {
        return assetAccreditMapper.deleteAssetAccreditById(id);
    }

    @Override
    public Result getAssetAccreditByDataAssetId(Long id) {
        List<AssetAccredit> assetAccreditList = assetAccreditMapper.getAssetAccreditByDataAssetId(id);
        List<Long> userAccreditIds = assetAccreditList.stream().map(AssetAccredit::getUserId).filter(Objects::nonNull).toList();
        List<Long> deptAccreditIds = assetAccreditList.stream().map(AssetAccredit::getDeptId).filter(Objects::nonNull).toList();
        AccreditModel accreditModel = new AccreditModel();
        accreditModel.setDeptAccreditModelIds(deptAccreditIds);
        accreditModel.setUserAccreditModelIds(userAccreditIds);
        return Result.success(accreditModel);
    }

    @Override
    public Result deleteAssetAccreditByAssetIds(AssetAccreditReq assetAccreditReq) {
        if (assetAccreditReq.getUserId() != null){
            assetAccreditMapper.deleteAssetAccreditByDeptUser(null,assetAccreditReq.getUserId(),assetAccreditReq.getDataAssetId());
        }else{
            List<Long> deptIds = assetAccreditReq.getDeptIds();
            Result<List<SysUser>> list = remoteUserService.userList(new SysUser());
            List<SysUser> sysUsers = list.getData();
            List<Long> userIds = sysUsers.stream()
                    .filter(sysUser -> deptIds.contains(sysUser.getDeptId())).toList().stream()
                    .filter(sysUser -> deptIds.contains(sysUser.getDeptId())).toList().stream()
                    .map(SysUser::getUserId).toList();
            assetAccreditMapper.deleteAssetAccreditByUser(userIds,assetAccreditReq.getDataAssetId());
            assetAccreditMapper.deleteAssetAccreditByDeptUser(assetAccreditReq.getDeptIds(),null,assetAccreditReq.getDataAssetId());
        }
        return null;
    }
}
