package com.muyu.etl.service.impl;

import com.alibaba.druid.pool.DruidDataSource;
import com.alibaba.fastjson.JSON;
import com.muyu.etl.config.RabbitAdminConfig;
import com.muyu.etl.datasource.MyDataSource;
import com.muyu.etl.domain.DataSource;
import com.muyu.etl.service.DataSourceProduct;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.sql.SQLException;

/**
 * @ClassName DataSourceProductImpl
 * @Description 描述
 * @Author Xin.Yao
 * @Date 2024/5/16 20:08
 */
@Service
public class DataSourceProductImpl  implements DataSourceProduct {
    @Autowired
    private RabbitTemplate rabbitTemplate;
    @Override
    public void dataSourceProduct(DataSource dataSource){

        try {
            String msg = JSON.toJSONString(dataSource);
            rabbitTemplate.convertAndSend(RabbitAdminConfig.DATA_SOURCE_EXCHANGE,"",msg);
            String jdbcUrl = "jdbc:"+dataSource.getType().toLowerCase()+"://"+dataSource.getLinkAddress()+":"+dataSource.getPort()+"/"+dataSource.getDatabaseName();
            String key = dataSource.getDataSourceName()+"_"+dataSource.getId();
            DruidDataSource druidDataSource = new DruidDataSource();
            //建立数据库连接
            druidDataSource.setUrl(jdbcUrl);
            druidDataSource.setUsername(dataSource.getUsername());
            druidDataSource.setPassword(dataSource.getPassword());
            //配置连接池信息
            druidDataSource.setInitialSize(Integer.valueOf(dataSource.getInitNum().toString()));
            druidDataSource.setMaxActive(Integer.valueOf(dataSource.getMaxNum().toString()));
            druidDataSource.setMinIdle(5);
            druidDataSource.init();
            MyDataSource.addDataSource(key,druidDataSource);
        } catch (SQLException e) {
            throw new RuntimeException(e);
        }

    }
}
