package com.muyu.etl.service.impl;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.DateUtils;
import com.muyu.common.security.utils.SecurityUtils;
import com.muyu.etl.domain.Dictionary;
import com.muyu.etl.domain.DictionaryData;
import com.muyu.etl.mapper.AssetModelMapper;
import com.muyu.etl.mapper.DictionaryDataMapper;
import com.muyu.etl.mapper.DictionaryMapper;
import com.muyu.etl.service.IDictionaryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author ruoyi
 * @date 2024-04-24
 */
@Service
public class DictionaryServiceImpl implements IDictionaryService
{
    @Autowired
    private DictionaryMapper dictionaryMapper;

    @Autowired
    private DictionaryDataMapper dictionaryDataMapper;

    @Autowired
    private AssetModelMapper assetModelMapper;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 【请填写功能名称】主键
     * @return 【请填写功能名称】
     */
    @Override
    public Dictionary selectDictionaryById(Long id)
    {
        return dictionaryMapper.selectDictionaryById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     *
     * @param dictionary 【请填写功能名称】
     * @return 【请填写功能名称】
     */
    @Override
    public List<Dictionary> selectDictionaryList(Dictionary dictionary)
    {
        return dictionaryMapper.selectDictionaryList(dictionary);
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param dictionary 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int insertDictionary(Dictionary dictionary)
    {
        dictionary.setCreateTime(DateUtils.getNowDate());
        dictionary.setCreateBy(SecurityUtils.getUsername());
        return dictionaryMapper.insertDictionary(dictionary);
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param dictionary 【请填写功能名称】
     * @return 结果
     */
    @Override
    public int updateDictionary(Dictionary dictionary)
    {
        dictionary.setUpdateTime(DateUtils.getNowDate());
        dictionary.setUpdateBy(SecurityUtils.getUsername());
        return dictionaryMapper.updateDictionary(dictionary);
    }

    /**
     * 批量删除【请填写功能名称】
     *
     * @param ids 需要删除的【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteDictionaryByIds(Long[] ids)
    {
        return dictionaryMapper.deleteDictionaryByIds(ids);
    }

    /**
     * 删除【请填写功能名称】信息
     *
     * @param id 【请填写功能名称】主键
     * @return 结果
     */
    @Override
    public int deleteDictionaryById(Long id)
    {
        return dictionaryMapper.deleteDictionaryById(id);
    }

    @Override
    public Result getDictionaryList(Long dataSourceId) {
        List<Dictionary> dictionaryList=dictionaryMapper.getDictionaryList(dataSourceId);
        if (!dictionaryList.isEmpty()){
            List<DictionaryData> dictionaryDataList=dictionaryDataMapper.getDictionaryDataList(dictionaryList.stream().map(Dictionary::getId).toList());
            dictionaryList.stream()
                    .forEach(dictionary -> {
                        List<DictionaryData> dictionaryDatas = dictionaryDataList.stream().filter(dictionaryData -> dictionaryData.getDictionaryId() == dictionary.getId()).toList();
                        dictionary.setDictionaryDataList(dictionaryDatas);
                    });
        }
        return Result.success(dictionaryList);
    }

    @Override
    @Transactional
    public Result deleteDictionary(Long id) {
        dictionaryDataMapper.deleteDictionaryData(id);
        dictionaryMapper.deleteDictionaryById(id);
        assetModelMapper.updAssetModelDict(id);
        return Result.success();
    }

    public Result getDictionaryDataList(List<String> strings) {
        List<Dictionary> dictionaryList = dictionaryMapper.getDictionaryDataList(strings);
        if (!dictionaryList.isEmpty()){
            List<DictionaryData> dictionaryDataList=dictionaryDataMapper.getDictionaryDataList(dictionaryList.stream().map(Dictionary::getId).toList());
            dictionaryList.stream()
                    .forEach(dictionary -> {
                        List<DictionaryData> dictionaryDatas = dictionaryDataList.stream().filter(dictionaryData -> dictionaryData.getDictionaryId() == dictionary.getId()).toList();
                        dictionary.setDictionaryDataList(dictionaryDatas);
                    });
        }
        return Result.success(dictionaryList);
    }
}
