package com.muyu.rabbitmq.producerservice.impl;

import com.alibaba.fastjson2.JSON;
import com.muyu.etl.domain.DataSource;
import com.muyu.rabbitmq.config.RabbitAdminConfig;
import com.muyu.rabbitmq.producerservice.DataSourceService;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @ClassName DataSourceServiceImpl
 * @Description 描述
 * @Author Xin.Yao
 * @Date 2024/5/16 19:56
 */
@Service
public class DataSourceServiceImpl implements DataSourceService {
    @Autowired
    private RabbitTemplate rabbitTemplate;

    @Override
    public void dataSourceProduct(DataSource dataSource) {
        //将对象转换成JSON格式
        String msg = JSON.toJSONString(dataSource);
        //将消息发送到交换机中
        rabbitTemplate.convertAndSend(RabbitAdminConfig.DATA_SOURCE_EXCHANGE,"",msg);
    }
}
