package com.muyu.rule.engine.scope;

import com.muyu.rule.engine.Engine;
import com.muyu.rule.model.DataModel;
import com.muyu.rule.scope.DataModelContext;
import com.muyu.rule.scope.model.DataProcessModel;

/**
 * @Author: YaoXin
 * @date: 2024/5/6
 * @Description: 数据模型引擎接口
 * @Version: 1.0
 */
public abstract class DataModelEngine implements Engine<DataProcessModel> {

    private DataModelContext dataModelContext;

    @Override
    public DataProcessModel get (){
        return dataModelContext.get();
    }

    public DataModel getDataModel(){
        return get().getDataModel();
    }


    public String getKey () {
        return getDataModel().getKey();
    }

    public Object getValue () {
        return getDataModel().getValue();
    }

    public String getSourceType () {
        return getDataModel().getSourceType();
    }

    public String getProcessType () {
        return getDataModel().getProcessType();
    }

    public Class<?> getProcessClass () {
        return getDataModel().getProcessClass();
    }

}
