package com.muyu.rule.engine.scope;

import com.muyu.rule.engine.Engine;
import com.muyu.rule.model.DataSetModel;
import com.muyu.rule.model.RecordModel;
import com.muyu.rule.scope.DataSetContext;
import com.muyu.rule.scope.model.DataSetProcessModel;

import java.util.List;

/**
 * @Author: YaoXin
 * @date: 2024/5/6
 * @Description: 数据模型引擎接口
 * @Version: 1.0
 */
public abstract class DataSetEngine implements Engine<DataSetProcessModel> {
    private DataSetContext dataSetContext;
    @Override
    public DataSetProcessModel get() {
        return dataSetContext.get();
    }

    public DataSetModel getDataSetModel() {
        return get().getDataSetModel();
    }

    public List<RecordModel> getRecordModelArr(){
        return getDataSetModel().getRecordModelArr();
    }

    public List<String> getKeys() {
        return get().getKeys();
    }
}
