package com.muyu.rule.engine.scope;

import com.muyu.rule.engine.Engine;
import com.muyu.rule.model.DataModel;
import com.muyu.rule.model.RecordModel;
import com.muyu.rule.scope.RecordContext;
import com.muyu.rule.scope.model.DataSetProcessModel;
import com.muyu.rule.scope.model.RecordProcessModel;

import java.util.List;

/**
 * @Author: YaoXin
 * @date: 2024/5/6
 * @Description: 数据模型引擎接口
 * @Version: 1.0
 */
public abstract class RecordEngine implements Engine<RecordProcessModel> {
    private RecordContext recordContext;

    @Override
    public RecordProcessModel get() {
        return recordContext.get();
    }

    public RecordModel getRecordModel() {
        return get().getRecordModel();
    }

    public List<String> getKeys() {
        return get().getKeys();
    }

    public List<DataModel> getDataModelArr() {
        return getRecordModel().getDataModelArr();
    }


}
