package com.muyu.rule.scope;

import com.muyu.rule.scope.model.DataProcessModel;
import com.muyu.rule.scope.model.RecordProcessModel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.stereotype.Component;

/**
 * @Author: YaoXin
 * @date: 2024/4/29
 * @Description: 数据模型
 * @Version: 1.0
 */
public class DataModelContext{

    private static final ThreadLocal<DataProcessModel> THREAD_LOCAL = new ThreadLocal<>();


    public static DataProcessModel get () {
        return THREAD_LOCAL.get();
    }


    public static void set (DataProcessModel dataProcessModel) {
        THREAD_LOCAL.set(dataProcessModel);
    }


    public static void clear(){
        THREAD_LOCAL.remove();
    }
}
