package com.muyu.rule.scope;

import com.muyu.rule.scope.model.DataSetProcessModel;
import org.springframework.stereotype.Component;

/**
 * @Author: YaoXin
 * @date: 2024/4/29
 * @Description: 数据集
 * @Version: 1.0
 */
@Component
public class DataSetContext{

    private static final ThreadLocal<DataSetProcessModel> THREAD_LOCAL = new ThreadLocal<>();

    private final TaskContext taskContext;

    public DataSetContext (TaskContext taskContext) {
        this.taskContext = taskContext;
    }



    public static DataSetProcessModel get() {
        return THREAD_LOCAL.get();
    }


    public static void clear() {
        THREAD_LOCAL.remove();
    }


    public static void set(DataSetProcessModel dataSetProcessModel) {
        THREAD_LOCAL.set(dataSetProcessModel);
    }
}
