package com.muyu.rule.scope;

import com.muyu.rule.scope.model.RecordProcessModel;

/**
 * @Author: YaoXin
 * @date: 2024/4/29
 * @Description: 记录/资产模型
 * @Version: 1.0
 */
public class RecordContext{

    private static final ThreadLocal<RecordProcessModel> THREAD_LOCAL = new ThreadLocal<>();

    private final DataSetContext dataSetContext;

    private RecordContext (DataSetContext dataSetContext) {
        this.dataSetContext = dataSetContext;
    }


    public static RecordProcessModel get() {
        return THREAD_LOCAL.get();
    }


    public static void clear() {
        THREAD_LOCAL.remove();
    }


    public static void set(RecordProcessModel recordProcessModel) {
        THREAD_LOCAL.set(recordProcessModel);
    }
}
