package com.muyu.rule.engine;

import com.muyu.common.core.constant.ServiceNameConstants;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.common.system.remote.factory.RemoteUserFallbackFactory;
import com.muyu.rule.engine.domain.EngineMaintenance;
import com.muyu.rule.engine.factory.RemoteRuleEngineFallbackFactory;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * @ClassName RemoteRuleEngineService
 * @Description 描述
 * @Author Xin.Yao
 * @Date 2024/5/9 14:29
 */
@FeignClient(contextId = "remoteRuleEngineService",
        value = ServiceNameConstants.RULE_ENGINE_SERVICE,
        fallbackFactory = RemoteRuleEngineFallbackFactory.class)
public interface RemoteRuleEngineService {
    @PostMapping("/maintenance/list")
    public Result<TableDataInfo<EngineMaintenance>> list(@RequestBody EngineMaintenance engineMaintenance);
}
