package com.muyu.rule.engine;

import com.muyu.common.core.constant.ServiceNameConstants;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.rule.engine.domain.EngineVersion;
import com.muyu.rule.engine.factory.RemoteRuleEngineFallbackFactory;
import com.muyu.rule.engine.factory.RemoteRuleVersionFallbackFactory;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;

/**
 * @ClassName RemoteRuleVersionService
 * @Description 描述
 * @Author Xin.Yao
 * @Date 2024/5/17 下午8:03
 */
@FeignClient(contextId = "remoteRuleVersionService",
        value = ServiceNameConstants.RULE_ENGINE_SERVICE,
        fallbackFactory = RemoteRuleVersionFallbackFactory.class)
public interface RemoteRuleVersionService {
    @GetMapping("/version/list")
    public Result<TableDataInfo<EngineVersion>> list(EngineVersion engineVersion);
}
