package com.muyu.rule.engine.factory;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.common.system.remote.factory.RemoteUserFallbackFactory;
import com.muyu.rule.engine.RemoteRuleEngineService;
import com.muyu.rule.engine.domain.EngineMaintenance;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

/**
 * @ClassName RemoteRuleEngineFallbackFactory
 * @Description 描述
 * @Author Xin.Yao
 * @Date 2024/5/9 14:31
 */
@Component
public class RemoteRuleEngineFallbackFactory implements FallbackFactory<RemoteRuleEngineService> {
    private static final Logger log = LoggerFactory.getLogger(RemoteRuleEngineFallbackFactory.class);
    @Override
    public RemoteRuleEngineService create(Throwable cause) {
        return new RemoteRuleEngineService() {
            @Override
            public Result<TableDataInfo<EngineMaintenance>> list(EngineMaintenance engineMaintenance) {
                return Result.error("规则引擎列表获取失败");
            }
        };
    }
}
