package com.muyu.rule.engine.factory;

import com.muyu.common.core.domain.Result;
import com.muyu.common.core.web.page.TableDataInfo;
import com.muyu.rule.engine.RemoteRuleVersionService;
import com.muyu.rule.engine.domain.EngineVersion;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

/**
 * @ClassName RemoteRuleVersionFallbackFactory
 * @Description 描述
 * @Author Xin.Yao
 * @Date 2024/5/17 下午8:03
 */
@Component
public class RemoteRuleVersionFallbackFactory implements FallbackFactory<RemoteRuleVersionService> {
    @Override
    public RemoteRuleVersionService create(Throwable cause) {
        return new RemoteRuleVersionService() {

            @Override
            public Result<TableDataInfo<EngineVersion>> list(EngineVersion engineVersion) {
                return Result.error("获取规则版本列表失败");
            }
        };
    }
}
