package com.muyu.rule.engine.controller;

import java.util.List;
import javax.servlet.http.HttpServletResponse;

import com.muyu.rule.engine.req.DataSourceAssetModelReq;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.muyu.common.log.annotation.Log;
import com.muyu.common.log.enums.BusinessType;
import com.muyu.common.security.annotation.RequiresPermissions;
import com.muyu.rule.engine.domain.EngineMaintenance;
import com.muyu.rule.engine.service.IEngineMaintenanceService;
import com.muyu.common.core.web.controller.BaseController;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.poi.ExcelUtil;
import com.muyu.common.core.web.page.TableDataInfo;

/**
 * 【请填写功能名称】Controller
 *
 * @author ruoyi
 * @date 2024-05-02
 */
@RestController
@RequestMapping("/maintenance")
public class EngineMaintenanceController extends BaseController
{
    @Autowired
    private IEngineMaintenanceService engineMaintenanceService;

    /**
     * 查询【请填写功能名称】列表
     */
    @PostMapping("/list")
    public Result<TableDataInfo<EngineMaintenance>> list(@RequestBody EngineMaintenance engineMaintenance)
    {
        startPage();
        List<EngineMaintenance> list = engineMaintenanceService.selectEngineMaintenanceList(engineMaintenance);
        return getDataTable(list);
    }

    /**
     * 导出【请填写功能名称】列表
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, EngineMaintenance engineMaintenance)
    {
        List<EngineMaintenance> list = engineMaintenanceService.selectEngineMaintenanceList(engineMaintenance);
        ExcelUtil<EngineMaintenance> util = new ExcelUtil<EngineMaintenance>(EngineMaintenance.class);
        util.exportExcel(response, list, "【请填写功能名称】数据");
    }

    /**
     * 获取【请填写功能名称】详细信息
     */
    @GetMapping(value = "/{id}")
    public Result getInfo(@PathVariable("id") Long id)
    {
        return success(engineMaintenanceService.selectEngineMaintenanceById(id));
    }

    /**
     * 测试方法
     * @param code
     * @return
     */
    @GetMapping(value = "/TestMethod")
    public Result testMethod(@RequestParam("code") String code)
    {
        return engineMaintenanceService.testMethod(code);
    }

    /**
     * 新增【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.INSERT)
    @PostMapping
    public Result add(@RequestBody EngineMaintenance engineMaintenance)
    {
        return toAjax(engineMaintenanceService.insertEngineMaintenance(engineMaintenance));
    }


    /**
     * 修改【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.UPDATE)
    @PutMapping
    public Result edit(@RequestBody EngineMaintenance engineMaintenance)
    {
        return toAjax(engineMaintenanceService.updateEngineMaintenance(engineMaintenance));
    }

    /**
     * 删除【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public Result remove(@PathVariable Long[] ids)
    {
        return toAjax(engineMaintenanceService.deleteEngineMaintenanceByIds(ids));
    }
}
