package com.muyu.rule.engine.controller;

import java.util.List;
import javax.servlet.http.HttpServletResponse;

import com.muyu.rule.engine.domain.EngineMaintenance;
import com.muyu.rule.engine.req.DataSourceAssetModelReq;
import com.muyu.rule.engine.req.TestInterfaceReq;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.muyu.common.log.annotation.Log;
import com.muyu.common.log.enums.BusinessType;
import com.muyu.common.security.annotation.RequiresPermissions;
import com.muyu.rule.engine.domain.EngineVersion;
import com.muyu.rule.engine.service.IEngineVersionService;
import com.muyu.common.core.web.controller.BaseController;
import com.muyu.common.core.domain.Result;
import com.muyu.common.core.utils.poi.ExcelUtil;
import com.muyu.common.core.web.page.TableDataInfo;

/**
 * 【请填写功能名称】Controller
 *
 * @author ruoyi
 * @date 2024-05-06
 */
@RestController
@RequestMapping("/version")
public class EngineVersionController extends BaseController
{
    @Autowired
    private IEngineVersionService engineVersionService;

    /**
     * 查询【请填写功能名称】列表
     */
    @GetMapping("/list")
    public Result<TableDataInfo<EngineVersion>> list(EngineVersion engineVersion)
    {
        startPage();
        List<EngineVersion> list = engineVersionService.selectEngineVersionList(engineVersion);
        return getDataTable(list);
    }

    /**
     * 导出【请填写功能名称】列表
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, EngineVersion engineVersion)
    {
        List<EngineVersion> list = engineVersionService.selectEngineVersionList(engineVersion);
        ExcelUtil<EngineVersion> util = new ExcelUtil<EngineVersion>(EngineVersion.class);
        util.exportExcel(response, list, "【请填写功能名称】数据");
    }

    /**
     * 获取【请填写功能名称】详细信息
     */
    @GetMapping(value = "/{id}")
    public Result getInfo(@PathVariable("id") Long id)
    {
        return success(engineVersionService.selectEngineVersionById(id));
    }

    /**
     * 新增【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.INSERT)
    @PostMapping
    public Result add(@RequestBody EngineVersion engineVersion)
    {
        return toAjax(engineVersionService.insertEngineVersion(engineVersion));
    }

    /**
     * 修改【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.UPDATE)
    @PutMapping
    public Result edit(@RequestBody EngineVersion engineVersion)
    {
        return toAjax(engineVersionService.updateEngineVersion(engineVersion));
    }

    /**
     * 获取数据域列表
     */
    @PostMapping("/GetDataRegionList")
    public Result getDataRegionList(@RequestBody DataSourceAssetModelReq dataSourceAssetModelReq)
    {
        return engineVersionService.getDataRegionList(dataSourceAssetModelReq);
    }

    /**
     * 生成规则版本代码
     */
    @Log(title = "生成规则版本代码】", businessType = BusinessType.UPDATE)
    @PostMapping("/GeneratedCode")
    public Result generatedCode(@RequestBody EngineVersion engineVersion)
    {
        return engineVersionService.generatedCode(engineVersion);
    }

    /**
     * 初始化规则引擎类
     */
    @PostMapping("/InitializeRuleEngine")
    public Result initializeRuleEngine(@RequestBody EngineVersion engineVersion)
    {
        return engineVersionService.initializeRuleEngine(engineVersion);
    }


    /**
     * 删除【请填写功能名称】
     */
    @Log(title = "【请填写功能名称】", businessType = BusinessType.DELETE)
	@DeleteMapping("/{ids}")
    public Result remove(@PathVariable Long[] ids)
    {
        return toAjax(engineVersionService.deleteEngineVersionByIds(ids));
    }

    /**
     * 测试规则版本
     * @return
     */
    @PostMapping("/TestRuleVersion")
    public Result testRuleVersion(@RequestBody TestInterfaceReq testInterfaceReq){
        return engineVersionService.testRuleVersion(testInterfaceReq);
    }
}
